#pragma once

#include <SDL2/SDL_events.h>  // for SDL_Event
#include <SDL2/SDL_rect.h>    // for SDL_Rect
#include <SDL2/SDL_render.h>  // for SDL_Renderer, SDL_Texture
#include <SDL2/SDL_stdinc.h>  // for Uint32
#include <string>             // for string, basic_string
#include "player.h"           // for playerSpawn_t
#include "scoreboard.h"       // for board_t
class Asset;
class Cheevos;
class Debug;
class Input;
class ItemTracker;
class Resource;
class Room;
class RoomTracker;
class Screen;
class Stats;
class Text;
struct JA_Music_t;
struct JA_Sound_t;
struct options_t;
struct section_t;

class Game
{
private:
	// Objetos y punteros
	SDL_Renderer *renderer;		  // El renderizador de la ventana
	SDL_Event *eventHandler;	  // Manejador de eventos
	Screen *screen;				  // Objeto encargado de manejar el renderizador
	Room *room;					  // Objeto encargado de gestionar cada habitación del juego
	Player *player;				  // Objeto con el jugador
	ItemTracker *itemTracker;	  // Lleva el control de los objetos recogidos
	RoomTracker *roomTracker;	  // Lleva el control de las habitaciones visitadas
	Asset *asset;				  // Objeto con la ruta a todos los ficheros de recursos
	Input *input;				  // Objeto pata gestionar la entrada
	Text *text;					  // Objeto para los textos del juego
	ScoreBoard *scoreboard;		  // Objeto encargado de gestionar el marcador
	Cheevos *cheevos;			  // Objeto encargado de gestionar los logros del juego
	Resource *resource;			  // Objeto con los recursos
	Debug *debug;				  // Objeto para gestionar la información de debug
	options_t *options;			  // Puntero a las opciones del juego
	Stats *stats;				  // Objeto encargado de gestionar las estadísticas
	SDL_Texture *roomNameTexture; // Textura para escribir el nombre de la habitación
	section_t *section;			  // Seccion actual dentro del juego

	// Variables
	JA_Music_t *music;		  // Musica que suena durante el juego
	Uint32 ticks;			  // Contador de ticks para ajustar la velocidad del programa
	Uint32 ticksSpeed;		  // Velocidad a la que se repiten los bucles del programa
	std::string currentRoom;  // Fichero de la habitación actual
	playerSpawn_t spawnPoint; // Lugar de la habitación donde aparece el jugador
	JA_Sound_t *deathSound;	  // Sonido a reproducir cuando muere el jugador
	board_t board;			  // Estructura con los datos del marcador
	bool paused;			  // Indica si el juego se encuentra en pausa
	bool blackScreen;		  // Indica si la pantalla está en negro. Se utiliza para la muerte del jugador
	int blackScreenCounter;	  // Contador para temporizar la pantalla en negro
	int totalItems;			  // Cantidad total de items que hay en el mapeado del juego
	SDL_Rect roomNameRect;	  // Rectangulo donde pintar la textura con el nombre de la habitación

	// Actualiza el juego, las variables, comprueba la entrada, etc.
	void update();

	// Pinta los objetos en pantalla
	void render();

	// Comprueba los eventos de la cola
	void checkEvents();

#ifdef DEBUG
	// Pone la información de debug en pantalla
	void updateDebugInfo();

	// Pone la información de debug en pantalla
	void renderDebugInfo();
#endif

	// Escribe el nombre de la pantalla
	void renderRoomName();

	// Cambia de habitación
	bool changeRoom(std::string file);

	// Comprueba el teclado
	void checkInput();

	// Comprueba si el jugador esta en el borde de la pantalla y actua
	void checkPlayerOnBorder();

	// Comprueba las colisiones del jugador con los enemigos
	bool checkPlayerAndEnemies();

	// Comprueba las colisiones del jugador con los objetos
	void checkPlayerAndItems();

	// Comprueba si el jugador esta vivo
	void checkIfPlayerIsAlive();

	// Comprueba si ha terminado la partida
	void checkGameOver();

	// Mata al jugador
	void killPlayer();

	// Recarga todas las texturas
	void reLoadTextures();

	// Cambia la paleta
	void switchPalette();

	// Establece la pantalla en negro
	void setBlackScreen();

	// Actualiza las variables relativas a la pantalla en negro
	void updateBlackScreen();

	// Dibuja la pantalla negra
	void renderBlackScreen();

	// Pone el color del marcador en función del color del borde de la habitación
	void setScoreBoardColor();

	// Comprueba si ha finalizado el juego
	bool checkEndGame();

	// Obtiene la cantidad total de items que hay en el mapeado del juego
	int getTotalItems();

	// Va a la habitación designada
	void goToRoom(int border);

	// Pone el juego en pausa
	void switchPause();

	// Da vidas al jugador cuando está en la Jail
	void checkRestoringJail();

	// Inicializa el diccionario de las estadísticas
	void initStats();

	// Pone el nombre de la habitación en la textura
	void fillRoomNameTexture();

	// Comprueba algunos logros
	void checkSomeCheevos();

	// Comprueba los logros de completar el juego
	void checkEndGameCheevos();

public:
	// Constructor
	Game(SDL_Renderer *renderer, Screen *screen, Resource *resource, Asset *asset, options_t *options, Input *input, section_t *section, Debug *debug);

	// Destructor
	~Game();

	// Bucle para el juego
	void run();
};